Queries::OrQuery< MatchFuncArgType, DataFuncArgType, needsConversion > Class Template Reference

a Query implementing AND: requires any child to be `true` More...

`#include <OrQuery.h>`

Inheritance diagram for Queries::OrQuery< MatchFuncArgType, DataFuncArgType, needsConversion >:

## Public Types

typedef Query< MatchFuncArgType, DataFuncArgType, needsConversion > | BASE
Public Types inherited from Queries::Query< MatchFuncArgType, MatchFuncArgType, false >
using | CHILD_TYPE = std::shared_ptr< Query< MatchFuncArgType, MatchFuncArgType, needsConversion > >
using | CHILD_VECT = std::vector< CHILD_TYPE >
using | CHILD_VECT_I = typename CHILD_VECT::iterator
using | CHILD_VECT_CI = typename CHILD_VECT::const_iterator
using | MATCH_FUNC_ARG_TYPE = MatchFuncArgType
using | DATA_FUNC_ARG_TYPE = MatchFuncArgType

## Public Member Functions

| OrQuery ()
bool | Match (const DataFuncArgType what) const override
Query< MatchFuncArgType, DataFuncArgType, needsConversion > * | copy () const override
| returns a copy of this Query More...
Public Member Functions inherited from Queries::Query< MatchFuncArgType, MatchFuncArgType, false >
| Query ()
virtual | ~Query ()
void | setNegation (bool what)
| sets whether or not we are negated More...
bool | getNegation () const
| returns whether or not we are negated More...
void | setDescription (const std::string &descr)
| sets our text description More...
void | setDescription (const char *descr)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...
const std::string & | getDescription () const
| returns our text description More...
virtual std::string | getFullDescription () const
| returns a fuller text description More...
void | setTypeLabel (const std::string &typ)
| sets our type label More...
void | setTypeLabel (const char *typ)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...
const std::string & | getTypeLabel () const
| returns our text label. More...
void | setMatchFunc (bool(*what)(MatchFuncArgType))
| sets our match function More...
void | setDataFunc (MatchFuncArgType(*what)(MatchFuncArgType))
| sets our data function More...
void | addChild (CHILD_TYPE child)
| adds a child to our list of children More...
CHILD_VECT_CI | beginChildren () const
| returns an iterator for the beginning of our child vector More...
CHILD_VECT_CI | endChildren () const
| returns an iterator for the end of our child vector More...
virtual bool | Match (const MatchFuncArgType arg) const
| returns whether or not we match the argument More...

## Additional Inherited Members

Public Attributes inherited from Queries::Query< MatchFuncArgType, MatchFuncArgType, false >
bool(*)(MatchFuncArgType) | getMatchFunc () const
| returns our match function: More...
MatchFuncArgType(*)(MatchFuncArgType) | getDataFunc () const
| returns our data function: More...
MatchFuncArgType(* | d_dataFunc )(MatchFuncArgType)
MatchFuncArgType(* | d_dataFuncSameType )(MatchFuncArgType)
Protected Member Functions inherited from Queries::Query< MatchFuncArgType, MatchFuncArgType, false >
MatchFuncArgType | TypeConvert (MatchFuncArgType what, Int2Type< false >) const
| calls our `dataFunc` (if it's set) on `what` and returns the result, otherwise returns `what` More...
MatchFuncArgType | TypeConvert (MatchFuncArgType what, Int2Type< true >) const
Protected Attributes inherited from Queries::Query< MatchFuncArgType, MatchFuncArgType, false >
MatchFuncArgType | d_val
MatchFuncArgType | d_tol
std::string | d_description
std::string | d_queryType
CHILD_VECT | d_children
bool | df_negate
bool(* | d_matchFunc )(MatchFuncArgType)
union {
MatchFuncArgType(* d_dataFunc )(DataFuncArgType)
MatchFuncArgType(* d_dataFuncSameType )(MatchFuncArgType)
}; |

## Detailed Description

### template<class MatchFuncArgType, class DataFuncArgType = MatchFuncArgType, bool needsConversion = false>
class Queries::OrQuery< MatchFuncArgType, DataFuncArgType, needsConversion >

a Query implementing AND: requires any child to be `true`

Definition at line 20 of file OrQuery.h.

## Member Typedef Documentation

## BASE

template<class MatchFuncArgType , class DataFuncArgType = MatchFuncArgType, bool needsConversion = false>

typedef Query<MatchFuncArgType, DataFuncArgType, needsConversion> Queries::OrQuery< MatchFuncArgType, DataFuncArgType, needsConversion >::BASE

Definition at line 23 of file OrQuery.h.

## Constructor & Destructor Documentation

## OrQuery()

template<class MatchFuncArgType , class DataFuncArgType = MatchFuncArgType, bool needsConversion = false>

Queries::OrQuery< MatchFuncArgType, DataFuncArgType, needsConversion >::OrQuery | ( |  | ) |

inline

Definition at line 24 of file OrQuery.h.

## Member Function Documentation

## copy()

template<class MatchFuncArgType , class DataFuncArgType = MatchFuncArgType, bool needsConversion = false>

Query<MatchFuncArgType, DataFuncArgType, needsConversion>* Queries::OrQuery< MatchFuncArgType, DataFuncArgType, needsConversion >::copy | ( |  | ) | const

inline override virtual

returns a copy of this Query

Notes:

- the caller is responsible for `delete`ing the result

Reimplemented from Queries::Query< MatchFuncArgType, MatchFuncArgType, false >.

Definition at line 40 of file OrQuery.h.

References Queries::Query< MatchFuncArgType, DataFuncArgType, needsConversion >::addChild(), Queries::Query< MatchFuncArgType, DataFuncArgType, needsConversion >::d_description, Queries::Query< MatchFuncArgType, DataFuncArgType, needsConversion >::d_queryType, and Queries::Query< MatchFuncArgType, DataFuncArgType, needsConversion >::setNegation().

## Match()

template<class MatchFuncArgType , class DataFuncArgType = MatchFuncArgType, bool needsConversion = false>

bool Queries::OrQuery< MatchFuncArgType, DataFuncArgType, needsConversion >::Match | ( | const DataFuncArgType | what | ) | const

inline override

Definition at line 26 of file OrQuery.h.

The documentation for this class was generated from the following file:

- OrQuery.h